# How to Contribute

Libfork is an open source project and welcomes community contributions.

## Prerequisites

As a contributor, you’ll want to be familiar with the libfork project and the repository layout. You should also know how to use it as explained in the [documentation](https://conorwilliams.github.io/libfork/) and how to set up your build development environment to configure, build, and test libfork as explained in the _for developers_ section of [BUILDING.md](BUILDING.md).

## Pull Requests

All contributions should be submitted via a pull request (PR) from a fork of the repository, you can find all [open PRs](https://github.com/ConorWilliams/libfork/pulls) on GitHub.

### Before contributing your changes

* Make sure you can build libfork and run all the tests with your patch.
* For a feature, provide a relevant test.
* Document your code and update the documentation as needed.
* Submit a pull request into the master branch.

Continuous Integration (CI) testing is enabled for the repository. Your pull request must pass all checks before it can be merged. We will review your contribution and may provide feedback to guide you if any additional fixes or modifications are necessary. When reviewed and accepted, your pull request will be merged into our GitHub repository.

## Attribution

This document is based on the [oneTBB contribution guidelines](https://github.com/oneapi-src/oneTBB/blob/master/CONTRIBUTING.md)
